/*#####################################################################################

  	X    X		DDD		FFFFFF			 222
	 X  X		D  D		F			2   2
	  XX	   	D   D		FFFF			   2
  	  XX 	  	D   D		F		v   v 	  2
	 X  X 		D  D		F	 	 v v 	 2				
        X    X		DDD		F		  v	22222

#######################################################################################

 xdf est une application X de visualisation et de modification ponctuelle (patch) de fichiers.
 Ce produit ecrit a l'origine par Francois DAGORN, a ete pourvu par Jean-Yves LELOUP
 des nouvelles fonctionalites suivantes :
 
 	- recherche de chaine textuelle (ascii), suite de nombres octals ou hexadecimaux
 	
 	- modification du fichier visualise par l'entree d'une chaine textuelle, octale,
	   ou encore hexadecimale

	- positionement a un endroit quelconque dans le fichier grace une fonction 'Aller a'

			

 
*/

#include "patchlevel.h"
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#ifndef _IBMR2
#include <sys/exec.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
#include <a.out.h>
#ifndef _IBMR2
#include <stab.h>
#endif

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Intrinsic.h>

#include <X11/StringDefs.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/AsciiText.h>

#include <X11/Xos.h>
#include <X11/cursorfont.h>
#include <X11/Shell.h>

#include <X11/Xaw/Box.h>

#include <X11/Xaw/Viewport.h>
#include <X11/Xaw/Paned.h>


#define LG10  300
#define LG16  240

Widget toplevel,form;
Widget cmdh[15],text,fic,textl,wallera,wrechercher,wmodifier;
Widget cmdb[15],cmdd[15];
static Widget nlig1,nlig2;
/* static ici car sinon "core dump" sur RS/6000  (Oups ..!) */
Widget popm,wdiag,wascii,woctal,whexa,wannulerm,wconfirmerm;


XawTextPosition Replace();
void octal(),hexa(),ascii(),ebcdic(),quitter(),rechercher_CB(),modifier_CB(),allera_CB();
void octalRech_CB(),asciiRech_CB(),hexaRech_CB(),octalModif_CB(),asciiModif_CB(),hexaModif_CB();
void annuler_CB(),annuler_dest(),goto_CB(),inhibe_btn_modifier(),desactive();

void next(),prev(),plus5(),moins5(),plus10(),moins10(),deb(),middle(),last();
void newfont(),newlig(),idec(),ihexa();
long TextLength();
void EraseTextWidget();

typedef void (*fptr) ();
fptr  fonc [] = {
	        octal,
                hexa,
                ascii,
                ebcdic,
                quitter
};

fptr foncdep [] = {
		next,
		prev,
		plus5,
		moins5,
		plus10,
		moins10,
		deb,
		middle,
		last
};

char *nomextb [] = {
		"next",
		"prev",
		"plus5",
		"moins5",
		"plus10",
		"moins10",
		"deb",
		"middle",
		"last"
};		

char *nomexth [] = {
	        "octal",
                "hexa",
                "ascii",
                "ebcdic",
                "quitter"
};

char *nomextd [] = {
		"small_font",
		"normal_font",
		"large_font",
		"base_10",
		"base_16"
};

char *nomextn[] = {
		"rechercher",
		"modifier",
		"allera",
};


static String   fallback_resources[] = {
	    "*octal.label:		Octal",
	    "*hexa.label:		Hexa",
	    "*ascii.label:		Ascii",
	    "*ebcdic.label:		Ebcdic",
	    "*quitter.label:		Quitter",
	    "*next.label:		Moncul",
	    "*prev.label:		Precedent",
	    "*plus5.label:		+5",
	    "*moins5.label:		-5",
	    "*plus10.label:		+10",
	    "*moins10.label:		-10",
	    "*deb.label:		Debut",
	    "*middle.label:		Milieu",
	    "*last.label:		Fin",
	    "*small_font.label:		Petite Police",
	    "*normal_font.label:	Police normale",
	    "*large_font.label:		Grande Police",
	    "*base_10.label:		Base 10",
	    "*base_16.label:		Base 16",
	    "*rechercher.label:		Rechercher",
	    "*modifier.label:		Modifier",
	    "*allera.label:		Aller a",
	    "*rechercherchaine.label:	Recherche de la chaine",
	    "*adresse.label:		Adresse de depart",
	    "*annuler.label:		Annuler",
	    "*valider.label:		Valider",
	    "*remplacement.label:	Chaine de remplacement",
             NULL,
};

typedef struct {
	String small_font;
	String normal_font;
	String large_font;
	int base;
} XdfRes, *XdfResources;
XdfRes MesRessources;

static XtResource resources[] = {
	{"smallFont","SmallFont",XtRString,sizeof (String),
		XtOffset(XdfResources,small_font),XtRString,"6x13"},
	{"normalFont","NormalFont",XtRString,sizeof (String),
		XtOffset(XdfResources,normal_font),XtRString,"9x15"},
	{"largeFont","LargeFont",XtRString,sizeof (String),
		XtOffset(XdfResources,large_font),XtRString,"10x20"},
	{"base","Base",XtRInt,sizeof (int),
		XtOffset(XdfResources,base),XtRString,"10"},				
};

static XFontStruct *fontptr;
int text_height,text_width,sm_text_width;
FILE *fichier;
char buff_source[1215];
char buff_hexa_octal[1215];
char buff_ascii_ebcdic[1215];
int conv = 1;
int interpascii = 1;
int nbcar[] = {LG10,LG10,LG10,LG10};
long finfich;
int nblu;
char numlig[120];
long posdeb;
int largeur_text,prof_text,modulo,modlf;
int decimal;
char *curfont,*filename;



   void annuler_CB(w,cl,ca)
/***********************/
	Widget w;
	XtPointer cl,ca;
{

	
	int nbcarac,nbecr,i;
	FILE *fichier_modif;
	


	
	/* dans le cas du widget  on rafraichi l`ecran pour eviter une desynchronisation */
	/* entre l`ecran (et le buffer) et les donnees du  fichier */
	
	if (((Widget)cl) == wannulerm || ((Widget)cl) == wconfirmerm ) {
		
		XtDestroyWidget(popm);


		if ((Widget)cl == wconfirmerm) {

			/*********** Mise a jour du fichier *****************/
			if (!(fichier_modif=fopen(filename,"r+"))) {
				fprintf(stderr,"xdf : ouverture en ecriture impossible\n");
				exit();
			}
			
			fseek(fichier_modif,posdeb,0);
			
			/********* Ajuste le nombre de caracteres a tranferer (fin de fichier) ***/
			if ((nbcarac = finfich - posdeb) > nbcar[conv]) nbcarac = nbcar[conv];
			
	
			if ((nbecr = fwrite(buff_source,sizeof(char),nbcarac,fichier_modif)) != nbcarac) {
			
				fprintf(stderr,"xdf : erreur d'ecriture\n");
			}
			
			/*********************************************/
			

			fclose(fichier_modif);
		}
			fclose(fichier);
			fichier = fopen(filename,"r");
			fseek(fichier,posdeb,0); 
			/********* Ajuste le nombre de caracteres a tranferer (fin de fichier) ***/
			if ((nbcarac = finfich - posdeb) > nbcar[conv]) nbcarac = nbcar[conv];

		
			if ((nblu = lirfich(posdeb,0,nbcarac,buff_source)) == -1) {
				fprintf(stderr,"xdf : erreur de lecture\n");
			}
			else fonc[conv]();
 
			/*********************************************/
			for(i=0;i<XtNumber(foncdep);i++)
				XtVaSetValues(cmdb[i],XtNsensitive,True,NULL);
		
		
	} else XtDestroyWidget((Widget)cl);



}
/*************************************************************/




   void annuler_dest(w,cl,ca)
/***********************/

	Widget w;
	XtPointer cl,ca;

{

	XtVaSetValues(wrechercher,XtNsensitive,True,NULL);
	XtVaSetValues(wallera,XtNsensitive,True,NULL);
	XtVaSetValues(wmodifier,XtNsensitive,True,NULL);
}
/*************************************************************/

   void asciiRech_CB(w,cl,ca)
/***********************/
/* Cette procedure recupere le contenu de la zone de dialogue a rechercher et effectue celle-ci */
/* a partir de l`adresse courante. Si la recherche reussie l`adresse courante est mise a jour   */


	Widget w;
	XtPointer cl,ca;
	
{

	
	char *text,*pchaine,trouve;
	long pos,adr_deb;
	int nbcarac;



	/********* Recupere le texte ascii ******/
	
	text = XawDialogGetValueString((Widget)cl);
	
	/********* La chaine ne peut etre vide ***********************/
	if (!strcmp(text,"\0")) {
		XBell(XtDisplay(toplevel),10);

	}

	else {
	
		/********  recherche de la chaine dans le fichier ***********/
		trouve = 0; /* flag faux */
		pos = ftell(fichier); /* memo de la position courante */
                fseek(fichier,posdeb+1,0);

		pchaine = text;
	
		while(!(feof(fichier)) && !(trouve)) {
			if (*pchaine == fgetc(fichier)) {
				pchaine++;
				if (!strncmp(pchaine,"\0",1)) trouve = 1;
			}
			else pchaine = text;
	
		} 	
		/******** lire un bloc a l`adresse demandee ***********************/
		if (trouve) {
		
			adr_deb = ftell(fichier) - strlen(text);

			
			if ((nbcarac = finfich - adr_deb) > nbcar[conv]) nbcarac = nbcar[conv];
			
			if ((nblu = lirfich(adr_deb,0,nbcarac,buff_source)) == -1) {
			fprintf(stderr,"xdf : erreur de lecture\n");
			}
			else {
				posdeb = ftell(fichier) - nblu;
				fonc[conv]();
			
			}
						

		
		}
		else {
			XBell(XtDisplay(toplevel),10);
			XBell(XtDisplay(toplevel),40);
			fseek(fichier,pos,0);

		}
	}



} /* fin de asciiRech_CB() */


   char format_ok(chaine,nbdigit)
/*********************************/
   	char chaine[];
   	int nbdigit;
{
	int i,longueur,t;
	
	
	longueur = strlen(chaine);
	if (chaine[longueur-1] != ' ') {
		longueur++;
		strcat(chaine," ");	
	}
	
	t = 0;
	for (i=0;i<longueur;i++)
	{
		if (chaine[i] != ' ') t++;
		else {
			
			if (t != nbdigit) return(1);
			else t = 0;
		}
		
	}
	
	return(0);

}

   void octalRech_CB(w,cl,ca)
/***********************/
/* Cette procedure recupere le contenu de la zone de dialogue a rechercher et effectue celle-ci */
/* a partir de l`adresse courante. Si la recherche reussie l`adresse courante est mise a jour   */


	Widget w;
	XtPointer cl,ca;
	
{

	
	char *text,trouve;
	long pos,adr_deb;
	int nbcarac,i,nbvar,oct[10];



	/********* Recupere le texte ascii ******/
	
	text = XawDialogGetValueString((Widget)cl);
	
	/********* La chaine ne peut etre vide et doit etre correctement formatee *******/
	if (!strcmp(text,"\0") || format_ok(text,3)) {
		XBell(XtDisplay(toplevel),10);

	}

	else {

		/******** convertion texte octal -> decimal **************/
				
                nbvar = sscanf(text,"%o %o %o %o %o %o %o %o %o %o",
				&oct[0],&oct[1],&oct[2],&oct[3],
					&oct[4],&oct[5],&oct[6],&oct[7],&oct[8],&oct[9]);

				
               /********  recherche de la chaine dans le fichier ***********/
		trouve = 0; /* flag faux */
		pos = ftell(fichier); /* memo de la position courante */
                fseek(fichier,posdeb+1,0);
		i=0;	
		while(!(feof(fichier)) && !(trouve)) {
			if (oct[i] == fgetc(fichier)) {
				i++;
				if (nbvar== i) trouve = 1;
			}
			else i=0;
	
		} 	
		/******** lire un bloc a l`adresse demandee ***********************/
		if (trouve) {
		
			adr_deb = ftell(fichier) - nbvar;
			if ((nbcarac = finfich - adr_deb) > nbcar[conv]) nbcarac = nbcar[conv];
		
			if ((nblu = lirfich(adr_deb,0,nbcarac,buff_source)) == -1) {
			fprintf(stderr,"xdf : erreur de lecture\n");
			}
			else {
				posdeb = ftell(fichier) -nblu;				
				fonc[conv]();

			}
						

		
		}
		else {
			XBell(XtDisplay(toplevel),10);
			XBell(XtDisplay(toplevel),40);
			fseek(fichier,pos,0);

		}
	}



} /* fin de octalRech_CB() */

   void hexaRech_CB(w,cl,ca)
/***********************/
/* Cette procedure recupere le contenu de la zone de dialogue a rechercher et effectue celle-ci */
/* a partir de l`adresse courante. Si la recherche reussie l`adresse courante est mise a jour   */


	Widget w;
	XtPointer cl,ca;
	
{
	
	char *text,trouve;
	long pos,adr_deb;
	int nbcarac,i,nbvar,oct[10];



	/********* Recupere le texte ascii ******/
	
	text = XawDialogGetValueString((Widget)cl);
	

	/********* La chaine ne peut etre vide ***********************/
	if (!strcmp(text,"\0") || format_ok(text,2)) {
		XBell(XtDisplay(toplevel),10);

	}

	else {


		/******** convertion texte hexa -> decimal **************/
				
                nbvar = sscanf(text,"%x %x %x %x %x %x %x %x %x %x",
				&oct[0],&oct[1],&oct[2],&oct[3],
					&oct[4],&oct[5],&oct[6],&oct[7],&oct[8],&oct[9]);

	
		
		/********  recherche de la chaine dans le fichier ***********/
		
		trouve = 0; /* flag faux */
		pos = ftell(fichier); /* memo de la position courante */
		fseek(fichier,posdeb+1,0);
		i=0;	
		while(!(feof(fichier)) && !(trouve)) {
			if (oct[i] == fgetc(fichier)) {
				i++;
				if (nbvar == i) trouve = 1;
			}
			else i=0;
	
		} 	
		/******** lire un bloc a l`adresse demandee ***********************/
		if (trouve) {
		
			adr_deb = ftell(fichier) - nbvar;
			if ((nbcarac = finfich - adr_deb) > nbcar[conv]) nbcarac = nbcar[conv];
		
			if ((nblu = lirfich(adr_deb,0,nbcarac,buff_source)) == -1) {
			fprintf(stderr,"xdf : erreur de lecture\n");
			}
			else {
				posdeb = ftell(fichier) - nblu;			
				fonc[conv]();
	
			}
						

		
		}
		else {
			XBell(XtDisplay(toplevel),10);
			XBell(XtDisplay(toplevel),40);
			fseek(fichier,pos,0);

		}
	}



} /* fin de hexaRech_CB() */


   void rechercher_CB()
/***********************/
{

Widget formr,popr,wdiagr,wasciir,woctalr,whexar,wannulerr,valr;
	

	char geo[50];
	Position x,y,x1,y1,x2,y2;
	Dimension width,height;
	char ch1[5],ch2[5];

	desactive();
	
	XtTranslateCoords(cmdh[4],(Position) 0,(Position) 0,&x1,&y1);
	XtTranslateCoords(wallera,(Position) 0,(Position) 0,&x2,&y2);
	x = x1-150+(x2-x1) / 2;
	y = y1+(y2-y1) / 2;
	sprintf(ch1,"%d",x);
	sprintf(ch2,"%d",y);
	
	strcpy(geo,"+");
	strcat(geo,ch1);
	strcat(geo,"+");
	strcat(geo,ch2);



	
	popr = XtVaCreatePopupShell("pop",wmShellWidgetClass,toplevel,
					XtNwaitForWm,False,
					XtNtransient,   True,
					XtNgeometry,    geo,
					XtNfont,        fontptr,
					NULL);


					
	formr = XtVaCreateManagedWidget("form",formWidgetClass,popr,NULL);

	wasciir = XtVaCreateManagedWidget("ascii",commandWidgetClass,formr,
				
        				XtNtop, 	XtChainTop,
     		   			XtNleft,	XtChainLeft,
        				XtNright,	XtChainLeft,
        				XtNbottom,	XtChainTop,
	        			XtNfont,	fontptr,
	        			
		       			NULL);


	woctalr = XtVaCreateManagedWidget("octal",commandWidgetClass,formr,
				
        				XtNtop, 	XtChainTop,
     		   			XtNleft,	XtChainLeft,
        				XtNright,	XtChainLeft,
        				XtNbottom,	XtChainTop,
	        			XtNfont,	fontptr,
	        			XtNfromHoriz,	wasciir,
		       			NULL);

	whexar = XtVaCreateManagedWidget("hexa",commandWidgetClass,formr,
				
        				XtNtop, 	XtChainTop,
     		   			XtNleft,	XtChainLeft,
        				XtNright,	XtChainLeft,
        				XtNbottom,	XtChainTop,
	        			XtNfont,	fontptr,
	        			XtNfromHoriz,	woctalr,
		       			NULL);

	wannulerr = XtVaCreateManagedWidget("quitter",commandWidgetClass,formr,
				
        				XtNtop, 	XtChainTop,
     		   			XtNleft,	XtChainLeft,
        				XtNright,	XtChainLeft,
        				XtNbottom,	XtChainTop,
	        			XtNfont,	fontptr,
	        			XtNfromHoriz,	whexar,
		       			NULL);

       	XtAddCallback(wannulerr,XtNcallback,annuler_CB,(XtPointer)popr);
       	XtAddCallback(wannulerr,XtNdestroyCallback,annuler_dest,(XtPointer)wrechercher);
	
	wdiagr = XtVaCreateManagedWidget("rechercherchaine",dialogWidgetClass,formr,
				
        				XtNtop, 	XtChainTop,
     		   			XtNleft,	XtChainLeft,
        				XtNright,	XtChainLeft,
        				XtNbottom,	XtChainTop,
	        			XtNfont,	fontptr,
		       			XtNvalue,	"",
					XtNfromVert,	wasciir,
					NULL);
	valr = XtNameToWidget(wdiagr,"value");
	XtVaSetValues(valr,
			XtNfont,fontptr,
			XtNwidth,370,
			NULL);

	valr = XtNameToWidget(wdiagr,"label");
	XtVaSetValues(valr,XtNfont,fontptr,NULL);
	

	
       	XtAddCallback(wasciir,XtNcallback,asciiRech_CB,(XtPointer)wdiagr);
       	XtAddCallback(woctalr,XtNcallback,octalRech_CB,(XtPointer)wdiagr);
       	XtAddCallback(whexar,XtNcallback,hexaRech_CB,(XtPointer)wdiagr);

       	XtVaSetValues(wdiagr,XtNfont,fontptr,NULL);
	XtPopup(popr,XtGrabNone);



		
}

/**********************************/


   void desactive()
{
	XtVaSetValues(wrechercher,XtNsensitive,False,NULL);
	XtVaSetValues(wmodifier,XtNsensitive,False,NULL);
	XtVaSetValues(wallera,XtNsensitive,False,NULL);

}



   void inhibe_btn_modifier()
/******************************/
{	
		XtVaSetValues(wascii,XtNsensitive,False,NULL);
		XtVaSetValues(woctal,XtNsensitive,False,NULL);
		XtVaSetValues(whexa,XtNsensitive,False,NULL);
	
}
/*****************************/



   void asciiModif_CB(w,cl,ca)
/***********************/
/* Cette procedure recupere le contenu de la zone de dialogue servant a la modification et effectue
 celle-ci a partir de l`adresse courante.                                                          */


	Widget w;
	XtPointer cl,ca;
	
{

	
	char *text;
	int nbcarac,i;

	

	/********* Recupere le texte ascii ******/
	
	text = XawDialogGetValueString((Widget)cl);

	
	/********* La chaine ne peut etre vide ***********************/
	if (!strcmp(text,"\0")) {
		XBell(XtDisplay(toplevel),10);

	}

	else {

		/********* rend inactif les boutons du widget MODIFIER **************/
		inhibe_btn_modifier();
	

		nbcarac = strlen(text);
		for (i=0;i<nbcarac;i++) {
			buff_source[i] = text[i];
		}
		
		fonc[conv]();
		XtVaSetValues(wconfirmerm,XtNsensitive,True,NULL);
	}



} /* fin de asciiModif_CB() */


   void octalModif_CB(w,cl,ca)
   /***********************/

/* Cette procedure recupere le contenu de la zone de dialogue servant a la modification et effectue
 celle-ci a partir de l`adresse courante.                                                          */

	Widget w;
	XtPointer cl,ca;
	
{

	
	char *text;
	int nbcarac,i,nbvar,oct[10];

	

	/********* Recupere le texte ascii ******/
	
	text = XawDialogGetValueString((Widget)cl);

	
	/********* La chaine ne peut etre vide ***********************/
	if (!strcmp(text,"\0") || format_ok(text,3)) {
	
		XBell(XtDisplay(toplevel),10);

	}

	else {

		/******** convertion texte octal -> decimal **************/
				
                nbvar = sscanf(text,"%o %o %o %o %o %o %o %o %o %o",
				&oct[0],&oct[1],&oct[2],&oct[3],
					&oct[4],&oct[5],&oct[6],&oct[7],&oct[8],&oct[9]);
		
		/********* rend inactif les boutons du widget MODIFIER **************/
		inhibe_btn_modifier();
			
		/********* met a jour le buffer *************/
		for (i=0;i<nbvar;i++) {
			buff_source[i] = oct[i];
		}
		
		fonc[conv]();
		XtVaSetValues(wconfirmerm,XtNsensitive,True,NULL);
		
	}
	
} /* fin de octalModif_CB() */




   void hexaModif_CB(w,cl,ca)
/***********************/
/* Cette procedure recupere le contenu de la zone de dialogue servant a la modification et effectue
 celle-ci a partir de l`adresse courante.                                                          */

	Widget w;
	XtPointer cl,ca;
	
{
	
	
	char *text;
	int nbcarac,i,nbvar,oct[10];

	

	/********* Recupere le texte ascii ******/
	
	text = XawDialogGetValueString((Widget)cl);

	
	/********* La chaine ne peut etre vide ***********************/
	if (!strcmp(text,"\0") || format_ok(text,2)) {
		XBell(XtDisplay(toplevel),10);

	}

	else {


		/******** convertion texte hexa -> decimal **************/
				
                nbvar = sscanf(text,"%x %x %x %x %x %x %x %x %x %x",
				&oct[0],&oct[1],&oct[2],&oct[3],
					&oct[4],&oct[5],&oct[6],&oct[7],&oct[8],&oct[9]);


		/********* rend inactif les boutons du widget MODIFIER **************/
		inhibe_btn_modifier();
			
		/********* met a jour le buffer *************/
		for (i=0;i<nbvar;i++) {
			buff_source[i] = oct[i];
		}
		
		fonc[conv]();
		XtVaSetValues(wconfirmerm,XtNsensitive,True,NULL);
		
	}

} /* fin de hexaModif_CB() */






   void modifier_CB()
/**********************/
{
Widget form,val;
	

	char geo[50];
	Position x,y,x1,y1,x2,y2;
	Dimension width,height;
	char ch1[5],ch2[5];

	int i;

	desactive();
	for(i=0;i<XtNumber(foncdep);i++)
		XtVaSetValues(cmdb[i],XtNsensitive,False,NULL);	
	
	XtTranslateCoords(cmdh[4],(Position) 0,(Position) 0,&x1,&y1);
	XtTranslateCoords(wallera,(Position) 0,(Position) 0,&x2,&y2);
	x = x1-150+(x2-x1) / 2 ;
	y = y1+(y2-y1) / 2;
	sprintf(ch1,"%d",x);
	sprintf(ch2,"%d",y+130);
	
	strcpy(geo,"+");
	strcat(geo,ch1);
	strcat(geo,"+");
	strcat(geo,ch2);



	
	popm = XtVaCreatePopupShell("pop",wmShellWidgetClass,toplevel,
					XtNwaitForWm,False,
					XtNtransient,   True,
					XtNgeometry,    geo,
					XtNfont,        fontptr,
					NULL);


					
	form = XtVaCreateManagedWidget("form",formWidgetClass,popm,NULL);

	wascii = XtVaCreateManagedWidget("ascii",commandWidgetClass,form,
					
        				XtNtop, 	XtChainTop,
     		   			XtNleft,	XtChainLeft,
        				XtNright,	XtChainLeft,
        				XtNbottom,	XtChainTop,
	        			XtNfont,	fontptr,
	        			
		       			NULL);


	woctal = XtVaCreateManagedWidget("octal",commandWidgetClass,form,
				
        				XtNtop, 	XtChainTop,
     		   			XtNleft,	XtChainLeft,
        				XtNright,	XtChainLeft,
        				XtNbottom,	XtChainTop,
	        			XtNfont,	fontptr,
	        			XtNfromHoriz,	wascii,
		       			NULL);

	whexa = XtVaCreateManagedWidget("hexa",commandWidgetClass,form,
				
        				XtNtop, 	XtChainTop,
     		   			XtNleft,	XtChainLeft,
        				XtNright,	XtChainLeft,
        				XtNbottom,	XtChainTop,
	        			XtNfont,	fontptr,
	        			XtNfromHoriz,	woctal,
		       			NULL);




	wannulerm = XtVaCreateManagedWidget("quitter",commandWidgetClass,form,
					
        				XtNtop, 	XtChainTop,
     		   			XtNleft,	XtChainLeft,
        				XtNright,	XtChainLeft,
        				XtNbottom,	XtChainTop,
	        			XtNfont,	fontptr,
	        			XtNfromHoriz,	whexa,
		       			NULL);



       	XtAddCallback(wannulerm,XtNcallback,annuler_CB,(XtPointer)wannulerm);
       	XtAddCallback(wannulerm,XtNdestroyCallback,annuler_dest,(XtPointer)wmodifier);

	wconfirmerm = XtVaCreateManagedWidget("valider",commandWidgetClass,form,
				
        				XtNtop, 	XtChainTop,
     		   			XtNleft,	XtChainLeft,
        				XtNright,	XtChainLeft,
        				XtNbottom,	XtChainTop,
	        			XtNfont,	fontptr,
	        			XtNfromHoriz,	wannulerm,
		       			NULL);

       	XtAddCallback(wconfirmerm,XtNcallback,annuler_CB,(XtPointer)wconfirmerm); 
	XtVaSetValues(wconfirmerm,XtNsensitive,False,NULL);

	
	wdiag = XtVaCreateManagedWidget("remplacement",dialogWidgetClass,form,
					
        				XtNtop, 	XtChainTop,
     		   			XtNleft,	XtChainLeft,
        				XtNright,	XtChainLeft,
        				XtNbottom,	XtChainTop,
	        			XtNfont,	fontptr,
		       			XtNvalue,	"",
					XtNfromVert,	wascii,
					NULL);


	val = XtNameToWidget(wdiag,"value");
	XtVaSetValues(val,XtNfont,fontptr,
			XtNwidth,370,NULL);

	val = XtNameToWidget(wdiag,"label");
	XtVaSetValues(val,XtNfont,fontptr,NULL);
	

	
		
       	XtAddCallback(wascii,XtNcallback,asciiModif_CB,(XtPointer)wdiag);
       	XtAddCallback(woctal,XtNcallback,octalModif_CB,(XtPointer)wdiag);
       	XtAddCallback(whexa,XtNcallback,hexaModif_CB,(XtPointer)wdiag);

	XtVaSetValues(wdiag,XtNfont,fontptr,NULL);
	XtPopup(popm,XtGrabNone);


}

/**********************************/

   void goto_CB(w,cl,ca)
/***********************/
/* Cette procedure recupere l`adresse a laquelle doit se positionner le pointeur courant et effectue la */
/* lecture si celle-ci est possible, sinon un bip sonore retenti                            */


	Widget w;
	XtPointer cl,ca;
	
{

	
	char *adr_text;
	int nbcarac;
	long adr_num,pos,taille;
	

	
	Widget val;


	adr_num = -1;

	/********* Recupere le texte et le converti en une adresse decimale ******/
	
	adr_text = XawDialogGetValueString((Widget)cl);
	if (modulo==20) sscanf(adr_text,"%7d",&adr_num);
	else sscanf(adr_text,"%7x",&adr_num);

	

	/********* L`adresse demandee ne peut exceder la longueur du fichier ***/
	if (adr_num > (finfich-1)) {
		XBell(XtDisplay(toplevel),10);
		XBell(XtDisplay(toplevel),40);
		adr_num = finfich-1;
		nbcarac = 1;
	}
	
	/********* Ajuste le nombre de caracteres a tranferer (fin de fichier) ***/
	if ((nbcarac = finfich - adr_num) > nbcar[conv]) nbcarac = nbcar[conv];


 	
	if (adr_num <0) XBell(XtDisplay(toplevel),10);	/* adresses negatives interdites ! */
	
	else {
		/******** lire un bloc a l`adresse demandee ***********************/

				
		if ((nblu = lirfich(adr_num,0,nbcarac,buff_source)) == -1) {
			fprintf(stderr,"xdf : erreur de lecture\n");
		}
		else {
			
			posdeb = adr_num;
			fonc[conv]();
		     }
						
		/*********************************************/
		
	}



} /* fin de goto_CB() */


   void allera_CB()
/*******************/


{

	
	Widget forma,popa,wdiaga,woka,wannulera,val;
	char geo[50];
	Position x,y,x1,y1,x2,y2;
	Dimension width,height;
	char ch1[5],ch2[5];
	
	desactive();
	
	XtTranslateCoords(cmdh[4],(Position) 0,(Position) 0,&x1,&y1);
	XtTranslateCoords(wallera,(Position) 0,(Position) 0,&x2,&y2);
	x = x1+(x2-x1) / 2;
	y = y1+(y2-y1) / 2;
	sprintf(ch1,"%d",x);
	sprintf(ch2,"%d",y+245);

	

	
	strcpy(geo,"+");
	strcat(geo,ch1);
	strcat(geo,"+");
	strcat(geo,ch2);

	

	
	popa = XtVaCreatePopupShell("pop",wmShellWidgetClass,toplevel,
					XtNwaitForWm,	False,
					XtNtransient,	True,
					XtNgeometry,	geo, 
					XtNfont,        fontptr,
					NULL);

	
					
	forma = XtVaCreateManagedWidget("form",formWidgetClass,popa,NULL);

	woka = XtVaCreateManagedWidget("valider",commandWidgetClass,forma,
				
        				XtNtop, 	XtChainTop,
     		   			XtNleft,	XtChainLeft,
        				XtNright,	XtChainLeft,
        				XtNbottom,	XtChainTop,
	        			XtNfont,	fontptr,
	        			
		       			NULL);


	
	wannulera = XtVaCreateManagedWidget("quitter",commandWidgetClass,forma,
				
        				XtNtop, 	XtChainTop,
     		   			XtNleft,	XtChainLeft,
        				XtNright,	XtChainLeft,
        				XtNbottom,	XtChainTop,
	        			XtNfont,	fontptr,
	        			XtNfromHoriz,	woka,
		       			NULL);

       	XtAddCallback(wannulera,XtNcallback,annuler_CB,(XtPointer)popa);
       	XtAddCallback(wannulera,XtNdestroyCallback,annuler_dest,(XtPointer)wallera);
	
	wdiaga = XtVaCreateManagedWidget("adresse",dialogWidgetClass,forma,
				
        				XtNtop, 	XtChainTop,
     		   			XtNleft,	XtChainLeft,
        				XtNright,	XtChainLeft,
        				XtNbottom,	XtChainTop,
	        			XtNfont,	fontptr,
		       			XtNvalue,	"",
					XtNfromVert,	woka,
						
					NULL);

	val = XtNameToWidget(wdiaga,"value");
	XtVaSetValues(val,XtNfont,fontptr,NULL);

	val = XtNameToWidget(wdiaga,"label");
	XtVaSetValues(val,XtNfont,fontptr,NULL);


	XtAddCallback(woka,XtNcallback,goto_CB,(XtPointer)wdiaga); 

	XtVaSetValues(wdiaga,XtNfont,fontptr,NULL);			
	XtPopup(popa,XtGrabNone);

	
}





  main(argc,argv)
/******************/

	int argc;
	int **argv;
	
  {
	Position x,y;
	Dimension width,height;

	XtAppContext context;
	int i;


	toplevel=XtAppInitialize(&context,"Xdf",NULL,0,&argc,argv,
						fallback_resources, NULL, 0);
        if (argc != 2) {
            fprintf(stderr,"xdf : nom du fichier obligatoire \n");
            exit(1);
        }

        if (ouvrable(argv[1]) == -1) exit(1);
        if ((fichier = fopen(argv[1],"r")) == NULL) {
          fprintf(stderr,"xdf : Ouverture de %s impossible \n",argv[1]);
          exit(1);
        }

	filename  = (char *)argv[1];
        
	XtGetApplicationResources(toplevel,&MesRessources,resources,XtNumber(resources),NULL,NULL,0);

	largeur_text = 81;
	prof_text = 16;
	modulo = 20;
	modlf = 19;
	decimal=0;
	if (MesRessources.base == 16)  {
		largeur_text = 65;
		prof_text = 16;
		modulo = 16;
		modlf = 15;
		decimal=1;
		for (i=0;i<4;i++) nbcar[i] = LG16;
	}
	
	fseek(fichier,0,2);
	finfich=ftell(fichier);        
        if ((nblu=lirfich(0,0,nbcar[0],buff_source)) == -1) {
		fprintf(stderr,"xdf : erreur de lecture \n");
		exit();
	}

	convhexa();
	convascii();
	curfont = MesRessources.normal_font;
	fontptr=XLoadQueryFont(XtDisplay(toplevel),MesRessources.normal_font);
	text_width = largeur_text * fontptr->max_bounds.width;
	sm_text_width = 8 * fontptr->max_bounds.width;
	text_height = prof_text * (fontptr->max_bounds.ascent + fontptr->max_bounds.descent);
        form = XtVaCreateManagedWidget("form",formWidgetClass,toplevel,NULL);
       	cmdh[0] = XtVaCreateManagedWidget(nomexth[0],commandWidgetClass,form,
       			XtNtop, 	XtChainTop,
       			XtNleft,	XtChainLeft,
       			XtNright,	XtChainLeft,
       			XtNbottom,	XtChainTop,
       			XtNfont,	fontptr,
       			XtNresizable,	True,
       			NULL);
        XtAddCallback(cmdh[0],XtNcallback,fonc[0],NULL);        
        for (i=1;i<XtNumber(fonc);i++) {
        	cmdh[i] = XtVaCreateManagedWidget(nomexth[i],commandWidgetClass,form,
        			XtNtop, 	XtChainTop,
        			XtNleft,	XtChainLeft,
        			XtNright,	XtChainLeft,
        			XtNbottom,	XtChainTop,
        			XtNfromHoriz,	cmdh[i-1],
        			XtNfont,	fontptr,
	       			XtNresizable,	True,
        			NULL);
        	XtAddCallback(cmdh[i],XtNcallback,fonc[i],NULL);
        }
	fic=XtVaCreateManagedWidget(fic,labelWidgetClass,form,
                                XtNtop,         XtChainTop,
                                XtNleft,        XtChainLeft,
                                XtNright,       XtChainLeft,
                                XtNbottom,      XtChainTop,
                                XtNfromHoriz,   cmdh[XtNumber(fonc)-1],
                                XtNfont,        fontptr,
                                XtNresizable,   True,
                                XtNlabel,	argv[1],
                                XtNborderWidth,	0,
                                NULL);
        nlig1=XtVaCreateManagedWidget("text",asciiTextWidgetClass,form,
				XtNstring,numlig,
				XtNuseStringInPlace,False,
				XtNtype,XawAsciiString,
				XtNtop,XtChainTop,
				XtNleft,XtChainLeft,
				XtNright,XtChainLeft,
				XtNbottom,XtChainTop,
				XtNfromVert,cmdh[0],
                                XtNfont,fontptr,
                                XtNheight,text_height,
                                XtNwidth,sm_text_width,
	       			XtNresizable,	True,
	       			XtNdisplayCaret, False,
				NULL);
                                
        text=XtVaCreateManagedWidget("text",asciiTextWidgetClass,form,
				XtNstring,buff_hexa_octal,
				XtNuseStringInPlace,False,
				XtNtype,XawAsciiString,
				XtNtop,XtChainTop,
				XtNleft,XtChainLeft,
				XtNright,XtChainLeft,
				XtNbottom,XtChainTop,
				XtNfromVert,cmdh[0],
				XtNfromHoriz,nlig1,
                                XtNfont,fontptr,
                                XtNheight,text_height,
                                XtNwidth,text_width,
	       			XtNresizable,	True,
	       			XtNdisplayCaret, False,	       			
				NULL);
				
        cmdb[0] = XtVaCreateManagedWidget(nomextb[0],commandWidgetClass,form,
                        XtNtop,         XtChainTop,
                        XtNleft,        XtChainLeft,
                        XtNright,       XtChainLeft,
                        XtNbottom,      XtChainTop,
                        XtNfromHoriz,	text,
                        XtNfromVert,	cmdh[0],
                        XtNfont,        fontptr,
       			XtNresizable,	True,                        
                        NULL);
        XtAddCallback(cmdb[0],XtNcallback,foncdep[0],NULL);
        for (i=1;i<XtNumber(foncdep);i++) {
                cmdb[i] = XtVaCreateManagedWidget(nomextb[i],commandWidgetClass,form,
                                XtNtop,         XtChainTop,
                                XtNleft,        XtChainLeft,
                                XtNright,       XtChainLeft,
                                XtNbottom,      XtChainTop,
                                XtNfromVert,    cmdb[i-1],
                                XtNfromHoriz,	text,
                                XtNfont,        fontptr,
	       			XtNresizable,	True,                                
                                NULL);
                XtAddCallback(cmdb[i],XtNcallback,foncdep[i],NULL);
        }

        nlig2=XtVaCreateManagedWidget("text",asciiTextWidgetClass,form,
				XtNstring,numlig,
				XtNuseStringInPlace,False,
				XtNtype,XawAsciiString,
				XtNtop,XtChainTop,
				XtNleft,XtChainLeft,
				XtNright,XtChainLeft,
				XtNbottom,XtChainTop,
				XtNfromVert,nlig1,
                                XtNfont,fontptr,
                                XtNheight,text_height,
                                XtNwidth,sm_text_width,
	       			XtNresizable,	True,
	       			XtNdisplayCaret, False,	       			
				NULL);
        
        textl=XtVaCreateManagedWidget("textl",asciiTextWidgetClass,form,
				XtNstring,buff_ascii_ebcdic,
				XtNuseStringInPlace,False,
				XtNtype,XawAsciiString,
				XtNtop,XtChainTop,
				XtNleft,XtChainLeft,
				XtNright,XtChainLeft,
				XtNbottom,XtChainTop,
				XtNfromVert,text,
				XtNfromHoriz,nlig2,
                                XtNfont,fontptr,
                                XtNheight,text_height,
                                XtNwidth,text_width,
	       			XtNresizable,	True,
	       			XtNdisplayCaret, False,	       				
				NULL);
        
        cmdd[0] = XtVaCreateManagedWidget(nomextd[0],commandWidgetClass,form,
                        XtNtop,         XtChainTop,
                        XtNleft,        XtChainLeft,
                        XtNright,       XtChainLeft,
                        XtNbottom,      XtChainTop,
                        XtNfromVert,	textl,
                        XtNfont,        fontptr,
       			XtNresizable,	True,                        
                        NULL);
        XtAddCallback(cmdd[0],XtNcallback,newfont,(caddr_t) MesRessources.small_font);
        cmdd[1] = XtVaCreateManagedWidget(nomextd[1],commandWidgetClass,form,
                        XtNtop,         XtChainTop,
                        XtNleft,        XtChainLeft,
                        XtNright,       XtChainLeft,
                        XtNbottom,      XtChainTop,
                        XtNfromVert,	textl,
                        XtNfromHoriz,	cmdd[0],
                        XtNfont,        fontptr,
       			XtNresizable,	True,                        
                        NULL);
        XtAddCallback(cmdd[1],XtNcallback,newfont,(caddr_t) MesRessources.normal_font);
        cmdd[2] = XtVaCreateManagedWidget(nomextd[2],commandWidgetClass,form,
                        XtNtop,         XtChainTop,
                        XtNleft,        XtChainLeft,
                        XtNright,       XtChainLeft,
                        XtNbottom,      XtChainTop,
                        XtNfromVert,	textl,
                        XtNfromHoriz,	cmdd[1],
                        XtNfont,        fontptr,
       			XtNresizable,	True,                        
                        NULL);
        XtAddCallback(cmdd[2],XtNcallback,newfont,(caddr_t) MesRessources.large_font);
        cmdd[3] = XtVaCreateManagedWidget(nomextd[3],commandWidgetClass,form,
                        XtNtop,         XtChainTop,
                        XtNleft,        XtChainLeft,
                        XtNright,       XtChainLeft,
                        XtNbottom,      XtChainTop,
                        XtNfromVert,	textl,
                        XtNfromHoriz,	cmdd[2],
                        XtNfont,        fontptr,
       			XtNresizable,	True,                        
                        NULL);
        XtAddCallback(cmdd[3],XtNcallback,idec,NULL);
        cmdd[4] = XtVaCreateManagedWidget(nomextd[4],commandWidgetClass,form,
                        XtNtop,         XtChainTop,
                        XtNleft,        XtChainLeft,
                        XtNright,       XtChainLeft,
                        XtNbottom,      XtChainTop,
                        XtNfromVert,	textl,
                        XtNfromHoriz,	cmdd[3],
                        XtNfont,        fontptr,
       			XtNresizable,	True,                        
                        NULL);
        XtAddCallback(cmdd[4],XtNcallback,ihexa,NULL);

        
        
/*************************** bouton Rechercher **********************************/

       wrechercher  = XtVaCreateManagedWidget("rechercher",commandWidgetClass,form,
                           XtNtop,         XtChainTop,
                           XtNleft,        XtChainLeft,
                           XtNright,       XtChainLeft,
                           XtNbottom,      XtChainTop,
                           XtNfromHoriz,   textl,
                           XtNfromVert,    cmdb[8],
                           XtNfont,        fontptr,
                           XtNresizable,   True,
                           NULL);
       XtAddCallback(wrechercher,XtNcallback,rechercher_CB,NULL); 

/*****************************************************************************/

/*************************** bouton Modifier **********************************/

       wmodifier  = XtVaCreateManagedWidget("modifier",commandWidgetClass,form,
                           XtNtop,         XtChainTop,
                           XtNleft,        XtChainLeft,
                           XtNright,       XtChainLeft,
                           XtNbottom,      XtChainTop,
                           XtNfromHoriz,   text,
                           XtNfromVert,    wrechercher,
                           XtNfont,        fontptr,
                           XtNresizable,   True,
                           NULL);
       XtAddCallback(wmodifier,XtNcallback,modifier_CB,NULL); 

/*****************************************************************************/



/*************************** bouton aller a **********************************/

       wallera  = XtVaCreateManagedWidget("allera",commandWidgetClass,form,
                           XtNtop,         XtChainTop,
                           XtNleft,        XtChainLeft,
                           XtNright,       XtChainLeft,
                           XtNbottom,      XtChainTop,
                           XtNfromHoriz,   text,
                           XtNfromVert,    wmodifier,
                           XtNfont,        fontptr,
                           XtNresizable,   True,
                           NULL);
       XtAddCallback(wallera,XtNcallback,allera_CB,NULL); 

/*****************************************************************************/


	XtRealizeWidget(toplevel);
#ifdef _IBMR2
/* grosse bug degueulasse sur RS/6000 , la 1ere fois le texte ne s'affiche pas
   dans la fenetre de texte en ascii  */
	octal();
#endif
	XtAppMainLoop(context);
}



   ouvrable (file)
/*******************/
	char *file;
{
#ifndef _IBMR2	
        struct exec exestruct;
#endif        
        int fd;
        struct stat statb;
        int resaccess;
        static char moi[] = "xdf";

        resaccess = access(file,F_OK);
        if (resaccess == -1) {
                fprintf(stderr,"%s: %s n'existe pas \n",moi,file);
                return(-1);
        }

        if (stat(file, &statb) < 0) {
                fprintf(stderr,"%s: probleme sur stat %s\n", moi, file);
                return(-1);
        }
        if ((statb.st_mode & S_IFMT) == S_IFDIR) {
                fprintf(stderr,"%s: %s est un repertoire \n", moi, file);
                return(-1);
        }
        if (statb.st_size == 0) {
                fprintf(stderr,"%s: %s est un fichier vide\n", moi, file);
                return(-1);
        }
       if ((fd = open(file,0)) < 0) {
                fprintf(stderr,"%s: %s n'est pas accessible \n", moi, file);
                return(-1);
       }
#ifndef _IBMR2       
        if (read(fd, &exestruct, sizeof(exestruct)) == sizeof(exestruct))
                switch(exestruct.a_magic) {
                  case OMAGIC:
                  case NMAGIC:
                  case ZMAGIC:
                    fprintf(stderr,"%s: %s est un programme executable \n", moi, file);
                    break;
                }
#endif                
        close(fd);
        return(0);
        }
	
   void newfont(widget,nfont,bid)
/*********************************/
	Widget widget;
	caddr_t nfont,bid;
{
	int i;
	int lgmax = 0;
	Dimension dim;
	int largeur,hauteur;
	Widget extended[3];

	extended[0] = wrechercher;
	extended[1] = wmodifier;
	extended[2] = wallera;



	
	curfont = (char *) MesRessources.large_font;
	fontptr=XLoadQueryFont(XtDisplay(toplevel),curfont);
	text_width = largeur_text * fontptr->max_bounds.width;
	text_height = prof_text * (fontptr->max_bounds.ascent + fontptr->max_bounds.descent);
	sm_text_width = 8 * fontptr->max_bounds.width;

	XawFormDoLayout(form,False);
	
	XtResizeWidget(toplevel,2*text_width+sm_text_width,3*text_height,1);


	curfont = (char *) nfont;	
	fontptr=XLoadQueryFont(XtDisplay(toplevel),curfont);
	text_width = largeur_text * fontptr->max_bounds.width;
	text_height = prof_text * (fontptr->max_bounds.ascent + fontptr->max_bounds.descent);
	sm_text_width = 8 * fontptr->max_bounds.width;


	
	for (i=0;i<XtNumber(nomextb);i++) {
		
                XtVaSetValues(cmdb[i],XtNfont,fontptr,NULL);
                XtVaGetValues(cmdb[i],XtNwidth,&dim,NULL);
                if (dim > lgmax) lgmax = dim;

        }

	for (i=0;i<3;i++) {
                XtVaSetValues(extended[i],XtNfont,fontptr,NULL);
                XtVaGetValues(extended[i],XtNwidth,&dim,NULL);
                if (dim > lgmax) lgmax = dim;
        }

        
        for (i=0;i<XtNumber(nomexth);i++) {
                XtVaSetValues(cmdh[i],XtNfont,fontptr,NULL);
                
        }
        for (i=0;i<XtNumber(nomextd);i++) {
        	XtVaSetValues(cmdd[i],XtNfont,fontptr,NULL);
        }

        XtVaSetValues(fic,XtNfont,fontptr,NULL);



        XtVaGetValues(cmdd[0],XtNheight,&dim,NULL);
        hauteur=dim;


	
        XtVaSetValues(text,XtNfont,fontptr,NULL);
        XtVaSetValues(text,XtNheight,text_height,NULL);                
        XtVaSetValues(text,XtNwidth,text_width,NULL);

        XtVaSetValues(textl,XtNfont,fontptr,NULL);
        XtVaSetValues(textl,XtNheight,text_height,NULL);                
        XtVaSetValues(textl,XtNwidth,text_width,NULL);

        XtVaSetValues(nlig1,XtNfont,fontptr,NULL);
        XtVaSetValues(nlig1,XtNheight,text_height,NULL);
        XtVaSetValues(nlig1,XtNwidth,sm_text_width,NULL);

        XtVaSetValues(nlig2,XtNfont,fontptr,NULL);
        XtVaSetValues(nlig2,XtNheight,text_height,NULL);
        XtVaSetValues(nlig2,XtNwidth,sm_text_width,NULL);

	XtResizeWidget(toplevel,text_width + sm_text_width + lgmax+25,2 * (text_height+hauteur)+30,1);

	XawFormDoLayout(form,True);

}

  lirfich(position,depuis,longueur,buff)
/****************************************/
	long position;
	int depuis,longueur;
	char *buff;
{
	int nb;

	fseek(fichier,position,depuis);
	nb=fread(buff,longueur,1,fichier);
	if (nb == 1) 	{
		posdeb = ftell(fichier) - longueur;
		return(longueur);		
	}
	else
	{
		posdeb = 0;
		return(finfich % longueur);		
	}
}
	
  void octal()
/**************/
{
        XawTextBlock block;
        long longueur;
        int lgbuf;

        XtVaSetValues(text,XtNeditType,XawtextEdit,NULL);        
	conv=0;
	lgbuf=convoct();
	EraseTextWidget(text);
        block.ptr= &buff_hexa_octal[0];
        block.length=lgbuf;
        block.firstPos = 0;
        block.format = FMT8BIT;
        XawTextReplace(text, 0,TextLength(text) , &block);
        XtVaSetValues(text,XtNeditType,XawtextRead,NULL);        
        if (interpascii == 1) ascii();
        else ebcdic();
        newlig();
                
}

   convoct()
/*************/
{
	unsigned char temp[2400];
	char tabcar[4];
	static char lf[] = "\012";
	int i;

	for (i=0;i<nblu;i++) temp[i] = buff_source[i];
	strcpy(buff_hexa_octal,"");
	for (i=0;i<nblu;i++) {
		tabcar[2] = temp[i] % 8 + 48;
		tabcar[1] = (temp[i] / 8) % 8 + 48;
		tabcar[0] = (temp[i] / 8) / 8 + 48;
		tabcar[3] = '\000';
		strcat(buff_hexa_octal,tabcar);
		strcat(buff_hexa_octal," ");
		if (i != 1) if ((i % modulo) == modlf) strcat(buff_hexa_octal,lf);
	}
	return(strlen(buff_hexa_octal));
}
  void hexa()
/*************/
{
	XawTextBlock block;
	long longueur;
	int lgbuf;

        XtVaSetValues(text,XtNeditType,XawtextEdit,NULL);
	conv=1;
	lgbuf=convhexa();
	EraseTextWidget(text);
	block.ptr= &buff_hexa_octal[0];
	block.length=lgbuf;
	block.firstPos = 0;
	block.format = FMT8BIT;
        XawTextReplace(text, 0,TextLength(text), &block);
        XtVaSetValues(text,XtNeditType,XawtextRead,NULL);        
        if (interpascii == 1) ascii();
        else ebcdic();
        newlig();

}

  void newlig()
/****************/
{
        XawTextBlock block;
        long longueur;
        int lgbuf;
        
        XtVaSetValues(nlig1,XtNeditType,XawtextEdit,NULL);
        XtVaSetValues(nlig2,XtNeditType,XawtextEdit,NULL);        
        EraseTextWidget(nlig1);
        EraseTextWidget(nlig2);
        block.ptr= &numlig[0];
        block.length=strlen(numlig);
        block.firstPos = 0;
        block.format = FMT8BIT;
        XawTextReplace(nlig1, 0,TextLength(nlig1), &block);
        XawTextReplace(nlig2, 0,TextLength(nlig2), &block);
        XtVaSetValues(nlig1,XtNeditType,XawtextRead,NULL);                
        XtVaSetValues(nlig2,XtNeditType,XawtextRead,NULL); 
                
}
  convhexa()
/************/
{
        unsigned char temp[1215];
        char tabcar[4];
        static char lf[] = "\012";
        int i;

        
	for (i=0;i<nblu;i++) temp[i] = buff_source[i];
        strcpy(buff_hexa_octal,"");
        for (i=0;i<nblu;i++) {
        	tabcar[0] = temp[i] / 16 + 48;
        	tabcar[1] = temp[i] % 16 + 48;
        	if (tabcar[0] > 57) tabcar[0] = tabcar[0] + 39;
        	if (tabcar[1] > 57) tabcar[1] = tabcar[1] + 39;
        	tabcar[2] = '\000';
                strcat(buff_hexa_octal,tabcar);
                strcat(buff_hexa_octal,"  ");
                if (i != 1) if ((i % modulo) == modlf) strcat(buff_hexa_octal,lf);
        }
        return(strlen(buff_hexa_octal));
}

  void ascii()
/**************/
{
        XawTextBlock block;
        long longueur;
        int lgbuf;
        
        XtVaSetValues(textl,XtNeditType,XawtextEdit,NULL);
        interpascii = 1;
        lgbuf=convascii();
        EraseTextWidget(textl);
        block.ptr= &buff_ascii_ebcdic[0];
        block.length=lgbuf;
        block.firstPos = 0;
        block.format = FMT8BIT;
        XawTextReplace(textl, 0,TextLength(textl), &block);
        XtVaSetValues(textl,XtNeditType,XawtextRead,NULL);        
}

  void ebcdic()
/***************/
{
        XawTextBlock block;
        long longueur;
        int lgbuf;

        XtVaSetValues(textl,XtNeditType,XawtextEdit,NULL);        	
	interpascii = 0;
	lgbuf=convebcdic();
        EraseTextWidget(textl);
        block.ptr= &buff_ascii_ebcdic[0];
        block.length=lgbuf;
        block.firstPos = 0;
        block.format = FMT8BIT;
        XawTextReplace(textl, 0,TextLength(textl), &block);
        XtVaSetValues(textl,XtNeditType,XawtextRead,NULL);        
	
}

  convebcdic()
/**************/
{
	unsigned char temp[1215];
        static char lf[] = "\012";
        char tabcar[5];
static	unsigned char	etoa[] =
{
	0000,0001,0002,0003,0234,0011,0206,0177,
	0227,0215,0216,0013,0014,0015,0016,0017,
	0020,0021,0022,0023,0235,0205,0010,0207,
	0030,0031,0222,0217,0034,0035,0036,0037,
	0200,0201,0202,0203,0204,0012,0027,0033,
	0210,0211,0212,0213,0214,0005,0006,0007,
	0220,0221,0026,0223,0224,0225,0226,0004,
	0230,0231,0232,0233,0024,0025,0236,0032,
	0040,0240,0241,0242,0243,0244,0245,0246,
	0247,0250,0133,0056,0074,0050,0053,0174,
	0046,0251,0252,0253,0254,0255,0256,0257,
	0260,0261,0041,0044,0052,0051,0073,0136,
	0055,0057,0262,0263,0264,0265,0266,0267,
	0270,0271,0174,0054,0045,0137,0076,0077,
	0272,0273,0274,0275,0276,0277,0300,0301,
	0302,0140,0072,0043,0100,0047,0075,0042,
	0303,0141,0142,0143,0144,0145,0146,0147,
	0150,0151,0304,0305,0306,0307,0310,0311,
	0312,0152,0153,0154,0155,0156,0157,0160,
	0161,0162,0313,0314,0315,0316,0317,0320,
	0321,0176,0163,0164,0165,0166,0167,0170,
	0171,0172,0322,0323,0324,0133,0326,0327,
	0330,0331,0332,0333,0334,0335,0336,0337,
	0340,0341,0342,0343,0344,0135,0346,0347,
	0173,0101,0102,0103,0104,0105,0106,0107,
	0110,0111,0350,0351,0352,0353,0354,0355,
	0175,0112,0113,0114,0115,0116,0117,0120,
	0121,0122,0356,0357,0360,0361,0362,0363,
	0134,0237,0123,0124,0125,0126,0127,0130,
	0131,0132,0364,0365,0366,0367,0370,0371,
	0060,0061,0062,0063,0064,0065,0066,0067,
	0070,0071,0372,0373,0374,0375,0376,0377,
};
static char *asciitable[] = {
	"Nul ","Soh ","Stx ","Etx ","Eot ","Enq ","Ack ","Bel ","Bsp ",
	"Tab ","Lf  ","Vt  ","Ff  ","Cr  ","So  ","Si  ","Dle ","Dc1 ",
	"Dc2 ","Dc3 ","Dc4 ","Nak ","Syn ","Etb ","Can ","Em  ","Sub ",
	"Esc ","Fs  ","Gs  ","Rs  ","Us  "
};
int i,j;
long nbyte;
unsigned int k;

	j=0;
	nbyte=posdeb;
	for (i=0;i<nblu;i++) temp[i] = buff_source[i];
	for (i=0;i<nblu;i++) {
		temp[i] = etoa[temp[i]];
	}
	strcpy(buff_ascii_ebcdic,"");
	for (i=0;i<nblu;i++) {
		if (temp[i] < 127) {
			if (temp[i] < 32) strcpy(tabcar,asciitable[temp[i]]);
			else {
				tabcar[0] = temp[i];
				tabcar[1] = '\000';
				strcat(tabcar,"   ");
			}
		}
		else
			strcpy(tabcar,".   ");
		strcat(buff_ascii_ebcdic,tabcar);
                if ((i % modulo) == 0) {
			if (decimal == 0)	sprintf(&numlig[j],"%7d",nbyte);
			else sprintf(&numlig[j],"%7x",nbyte);
			numlig[j+7] = lf[0];
			j=j+8;
			nbyte=nbyte+modulo;
		}
                if ((i % modulo ) == modlf) strcat(buff_ascii_ebcdic,lf);
	}
	numlig[j]='\000';
	return(strlen(buff_ascii_ebcdic));
}

   convascii()
/***************/
{
	unsigned char temp[1215];
	static char lf[] = "\012";
	char tabcar[5];
	static char *asciitable[] = {
		"Nul ","Soh ","Stx ","Etx ","Eot ","Enq ","Ack ","Bel ","Bsp ",
		"Tab ","Lf  ","Vt  ","Ff  ","Cr  ","So  ","Si  ","Dle ","Dc1 ",
		"Dc2 ","Dc3 ","Dc4 ","Nak ","Syn ","Etb ","Can ","Em  ","Sub ",
		"Esc ","Fs  ","Gs  ","Rs  ","Us  "
	};

	int i,j;
	long nbyte;

	j=0;
	nbyte=posdeb;
	for (i=0;i<nblu;i++) temp[i] = buff_source[i];
	strcpy(buff_ascii_ebcdic,"");
	
	for (i=0;i<nblu;i++) {
		if (temp[i] < 127) {
			if (temp[i] < 32) strcpy(tabcar,asciitable[temp[i]]);
			else {
				tabcar[0] = temp[i];
				tabcar[1] = '\000';
				strcat(tabcar,"   ");
			}
		}
		else
			strcpy(tabcar,".   ");
		strcat(buff_ascii_ebcdic,tabcar);
                if (i % modulo == 0) {
			if (decimal == 0)	sprintf(&numlig[j],"%7d",nbyte);
			else sprintf(&numlig[j],"%7x",nbyte);
			numlig[j+7] = lf[0];
			j=j+8;
			nbyte=nbyte+modulo;
		}
		if ((i % modulo ) == modlf) strcat(buff_ascii_ebcdic,lf);
	}
	numlig[j]='\000';



	return(strlen(buff_ascii_ebcdic));
}

  void idec()
/**************/
{
	int i;
	
        largeur_text = 81;
        prof_text = 16;
        modulo = 20;
        modlf = 19;
        decimal=0;
        for (i=0;i<4;i++) nbcar[i] = LG10;
        if (posdeb+nbcar[conv] > finfich) posdeb=finfich-nbcar[conv];
        if (posdeb < 0) posdeb = 0;
        nblu=lirfich(posdeb,0,nbcar[conv],buff_source);
        fonc[conv]();
        if (interpascii == 1) ascii();
        else ebcdic();
        newfont(text,curfont);
}

  void ihexa()
/**************/
{
	int i;
	
        largeur_text = 65;
        prof_text = 16;
        modulo = 16;
        modlf = 15;
        decimal=1;
        for (i=0;i<4;i++) nbcar[i] = LG16;
        if (posdeb+nbcar[conv] > finfich) posdeb=finfich-nbcar[conv];
        if (posdeb < 0) posdeb = 0;
        nblu=lirfich(posdeb,0,nbcar[conv],buff_source);        
        fonc[conv]();
        if (interpascii == 1) ascii();
        else ebcdic();
        newfont(text,curfont);
	
}

  void next(top,retour)
/************************/
  int top,*retour;
{
	if ((ftell(fichier) + nbcar[conv]) <= finfich) {
		if ((nblu=lirfich(0,1,nbcar[conv],buff_source)) == -1) {
			fprintf(stderr,"xdf : erreur de lecture \n");
			exit();
		}
		if (top == 1)	*retour = 0;
	}
	else {
		if (finfich > nbcar[conv]) 
			fseek(fichier,finfich-nbcar[conv],0);
		else
			fseek(fichier,0,0);
		if ((nblu=lirfich(0,1,nbcar[conv],buff_source)) == -1) {
                        fprintf(stderr,"xdf : erreur de lecture \n");
                        exit();
                }
		XBell( XtDisplay(toplevel), 10);
		if (top == 1) *retour = -1;
	}
	if (top != 1)	fonc[conv]();
}

  void prev(top,retour)
/************************/
  int top,*retour;
{
	if ((ftell(fichier) -  (2 * nbcar[conv])) > 0) {
		fseek(fichier,ftell(fichier)-(2*nbcar[conv]),0);
		if ((nblu=lirfich(0,1,nbcar[conv],buff_source)) == -1) {
		        fprintf(stderr,"xdf : erreur de lecture \n");
        	        exit();
	        }
	        if (top == 1) *retour = 0;
	}
	else {
		if ((nblu=lirfich(0,0,nbcar[conv],buff_source)) == -1) {
                        fprintf(stderr,"xdf : erreur de lecture \n");
                        exit();
		}
		XBell( XtDisplay(toplevel), 10);
		if (top == 1) *retour = -1;
	}
	if (top != 1) fonc[conv]();
}

  void moins5()
/***************/
{
	int ret,i;

	for (i=0;i<5;i++) {
		prev(1,&ret);
		if (ret == -1) break;
	}
	fonc[conv]();
}

  void plus5()
/**************/
{
	int ret,i;
	
	for (i=0;i<5;i++) {
		next(1,&ret);
		if (ret == -1) break;
	}
	fonc[conv]();	
}

  void moins10()
/****************/
{
        int ret,i;

        for (i=0;i<10;i++) {
                prev(1,&ret);
                if (ret == -1) break;
        }
        fonc[conv]();
	
}

  void plus10()
/***************/
{
        int ret,i;

        for (i=0;i<10;i++) {
                next(1,&ret);
                if (ret == -1) break;
        }
        fonc[conv]();
}

  void deb()
/************/
{
	if ((nblu=lirfich(0,0,nbcar[conv],buff_source)) == -1) {
		fprintf(stderr,"xdf : erreur de lecture \n");
		exit();
	}
	fonc[conv]();
	
}

  void middle()
/***************/
{
	long pos,adr_deb;
	int nbcarac;

	adr_deb = finfich / 2;

			
	if ((nbcarac = finfich - adr_deb) > nbcar[conv]) nbcarac = nbcar[conv];
	
	if ((nblu = lirfich(adr_deb,0,nbcarac,buff_source)) == -1) {
		fprintf(stderr,"xdf : erreur de lecture\n");
	}
	else {
				
		fonc[conv]();
		posdeb += nblu;
	}
						
}

  void last()
/*************/
{
	long pos;

	pos = finfich - nbcar[conv];
	if (pos < 0) pos = 0;
	fseek(fichier,pos,0);
	if ((nblu=lirfich(0,1,nbcar[conv],buff_source)) == -1) {
		fprintf(stderr,"xdf : erreur de lecture \n");
	exit();
	}
	fonc[conv]();
        	                                
}

  void quitter()
/****************/
{
	exit();
}


 long TextLength (w)
/*********************/
    Widget  w;
    {
    	    return XawTextSourceScan (XawTextGetSource (w),
                         (XawTextPosition) 0,
                          XawstAll, XawsdRight, 1, TRUE);
    }


  void  EraseTextWidget (widget)
/*********************************/
	Widget widget;
{
    XawTextBlock block;

    block.ptr = "";
    block.length = 0;
    block.firstPos = 0;
    block.format = FMT8BIT;

    XawTextReplace(widget, 0,100000 , &block);
}

    
